// This file is automatically generated by Citron version 2.0.
//
// The parser class defined below conforms to the CitronParser protocol
// defined in CitronParser.swift. 
// 
// The authors of Citron disclaim copyright to the source code in this file.

// Parser class

class SGFParser: CitronParser {

    // Types

    typealias CitronSymbolNumber = UInt8
    typealias CitronStateNumber = UInt8
    typealias CitronRuleNumber = UInt8

    enum CitronTokenCode: CitronSymbolNumber {
      case OPEN_PARENTHESIS               =   1
      case CLOSE_PARENTHESIS              =   2
      case SEMICOLUMN                     =   3
      case PROP_INDENT                    =   4
      case VALUE                          =   5
    }

    enum CitronNonTerminalCode: CitronSymbolNumber {
      case prop_value_list                =   6
      case property                       =   7
      case property_list                  =   8
      case node                           =   9
      case sequence                       =  10
      case gametree                       =  11
      case gametree_list                  =  12
      case collection                     =  13
      case output                         =  14
    }

    enum CitronSymbolCode : RawRepresentable, Equatable {
        case token(CitronTokenCode)
        case nonterminal(CitronNonTerminalCode)
        case endOfInput

        init(_ token: CitronTokenCode) { self = .token(token) }
        init(_ nonterminal: CitronNonTerminalCode) { self = .nonterminal(nonterminal) }
        init(rawValue: CitronSymbolNumber) {
            if (rawValue == 0) {
                self = .endOfInput
            } else if (rawValue < 6) {
                self = .token(CitronTokenCode(rawValue: rawValue)!)
            } else if (rawValue < 15) {
                self = .nonterminal(CitronNonTerminalCode(rawValue: rawValue)!)
            } else {
                fatalError()
            }
        }

        typealias RawValue = CitronSymbolNumber
        var rawValue: CitronSymbolNumber {
            switch (self) {
            case .token(let t): return t.rawValue
            case .nonterminal(let nt): return nt.rawValue
            case .endOfInput: return 0
            }
        }
    }

    typealias CitronToken = SGFToken

    enum CitronSymbol {
        case yyBaseOfStack
        case yy0(CitronToken)
        case yy2([(String, [String])])
        case yy10([String])
        case yy11([SGFNode])
        case yy27(SGFNode)
        case yy28((String, [String]))

        func typeErasedContent() -> Any {
            switch (self) {
            case .yyBaseOfStack: fatalError()
            case .yy0(let value): return value as Any
            case .yy2(let value): return value as Any
            case .yy10(let value): return value as Any
            case .yy11(let value): return value as Any
            case .yy27(let value): return value as Any
            case .yy28(let value): return value as Any
            }
        }
    }

    typealias CitronResult = [SGFNode]

    // Counts

    let yyNumberOfSymbols: Int = 15
    let yyNumberOfStates: Int = 12

    // Action tables

    let yyLookaheadAction: [(CitronSymbolNumber, CitronParsingAction)] = [
/*   0 */  (11, .SH( 7)), ( 1, .SH( 6)), (13, .SH(11)), (14, .ACCEPT),   ( 1, .SH( 6)),
/*   5 */  ( 2, .SR( 3)), (11, .SH( 5)), (12, .SH(10)), ( 7, .SH( 2)), ( 8, .RD(12)),
/*  10 */  ( 3, .SH( 3)), ( 7, .SH( 2)), ( 8, .RD(10)), ( 4, .SH( 9)), ( 9, .SH( 4)),
/*  15 */  (10, .RD( 8)), ( 5, .SH( 8)), (11, .SH( 5)), (12, .RD( 6)), ( 9, .SH( 4)),
/*  20 */  (10, .SH( 1)), ( 6, .RD(15)), ( 6, .RD(13)), (11, .SH( 7)), ( 2, .SR( 4)),
/*  25 */  (13, .RD( 2)), ( 0, .RD( 0)),
    ]

    let yyShiftUseDefault: Int = 27
    let yyShiftOffsetMin: Int = 0
    let yyShiftOffsetMax: Int = 26
    let yyShiftOffset: [Int] = [
        /*     0 */     0,    3,    9,    9,    7,    0,    7,    0,   11,   11,
        /*    10 */    22,   26,
    ]

    let yyReduceUseDefault: Int = -12
    let yyReduceOffsetMin: Int =   -11
    let yyReduceOffsetMax: Int =   16
    let yyReduceOffset: [Int] = [
        /*     0 */   -11,   -5,    1,    4,    5,    6,   10,   12,   15,   16,
    ]

    let yyDefaultAction: [CitronParsingAction] = [
  /*     0 */  .ERROR , .ERROR , .RD(11), .RD( 9), .RD( 7),
  /*     5 */  .RD( 5), .ERROR , .RD( 1), .RD(14), .ERROR ,
  /*    10 */  .ERROR , .ERROR ,
    ]

    // Fallback

    let yyHasFallback: Bool = false
    let yyFallback: [CitronSymbolNumber] = []

    // Wildcard

    let yyWildcard: CitronSymbolNumber? = nil

    // Rules

    let yyRuleInfo: [(lhs: CitronSymbolNumber, nrhs: UInt)] = [
        (lhs: 14, nrhs: 1),
        (lhs: 13, nrhs: 1),
        (lhs: 13, nrhs: 2),
        (lhs: 11, nrhs: 3),
        (lhs: 11, nrhs: 4),
        (lhs: 12, nrhs: 1),
        (lhs: 12, nrhs: 2),
        (lhs: 10, nrhs: 1),
        (lhs: 10, nrhs: 2),
        (lhs: 9, nrhs: 1),
        (lhs: 9, nrhs: 2),
        (lhs: 8, nrhs: 1),
        (lhs: 8, nrhs: 2),
        (lhs: 7, nrhs: 2),
        (lhs: 6, nrhs: 1),
        (lhs: 6, nrhs: 2),
    ]

    // Stack

    var yyStack: [(stateOrRule: CitronStateOrRule , symbolCode: CitronSymbolNumber, symbol: CitronSymbol)]  = [
        (stateOrRule: .state(0), symbolCode: 0, symbol: .yyBaseOfStack)
    ]
    var maxStackSize: Int? = nil
    var maxAttainedStackSize: Int = 0

    // Tracing

    var isTracingEnabled: Bool = false
    let yySymbolName: [String] = [
    /*  0 */ "$",
    /*  1 */ "OPEN_PARENTHESIS",
    /*  2 */ "CLOSE_PARENTHESIS",
    /*  3 */ "SEMICOLUMN",
    /*  4 */ "PROP_INDENT",
    /*  5 */ "VALUE",
    /*  6 */ "prop_value_list",
    /*  7 */ "property",
    /*  8 */ "property_list",
    /*  9 */ "node",
    /* 10 */ "sequence",
    /* 11 */ "gametree",
    /* 12 */ "gametree_list",
    /* 13 */ "collection",
    /* 14 */ "output",
    ]
    let yyRuleText: [String] = [
        /*   0 */ "output ::= collection(a)",
        /*   1 */ "collection ::= gametree(a)",
        /*   2 */ "collection ::= gametree(a) collection(b)",
        /*   3 */ "gametree ::= OPEN_PARENTHESIS sequence(a) CLOSE_PARENTHESIS",
        /*   4 */ "gametree ::= OPEN_PARENTHESIS sequence(a) gametree_list(b) CLOSE_PARENTHESIS",
        /*   5 */ "gametree_list ::= gametree(a)",
        /*   6 */ "gametree_list ::= gametree(a) gametree_list(b)",
        /*   7 */ "sequence ::= node(a)",
        /*   8 */ "sequence ::= node(a) sequence(b)",
        /*   9 */ "node ::= SEMICOLUMN",
        /*  10 */ "node ::= SEMICOLUMN property_list(a)",
        /*  11 */ "property_list ::= property(a)",
        /*  12 */ "property_list ::= property(a) property_list(b)",
        /*  13 */ "property ::= PROP_INDENT(a) prop_value_list(b)",
        /*  14 */ "prop_value_list ::= VALUE(a)",
        /*  15 */ "prop_value_list ::= VALUE(a) prop_value_list(b)",
    ]

    // Function definitions

    func yyTokenToSymbol(_ token: CitronToken) -> CitronSymbol {
        return .yy0(token)
    }

    func yyInvokeCodeBlockForRule(ruleNumber: CitronRuleNumber) throws -> CitronSymbol {
        switch (ruleNumber) {
        case 0: /* output ::= collection(a) */
            func codeBlockForRule00(a: [SGFNode]) throws -> [SGFNode] {
    return a
 }
            if case .yy11(let a) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy11(try codeBlockForRule00(a: a))
            }
        case 1: /* collection ::= gametree(a) */
            func codeBlockForRule01(a: SGFNode) throws -> [SGFNode] {
    return [a]
 }
            if case .yy27(let a) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy11(try codeBlockForRule01(a: a))
            }
        case 2: /* collection ::= gametree(a) collection(b) */
            func codeBlockForRule02(a: SGFNode, b: [SGFNode]) throws -> [SGFNode] {
    return [a] + b
 }
            if case .yy27(let a) = yySymbolOnStack(distanceFromTop: 1),
               case .yy11(let b) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy11(try codeBlockForRule02(a: a, b: b))
            }
        case 3: /* gametree ::= OPEN_PARENTHESIS sequence(a) CLOSE_PARENTHESIS */
            func codeBlockForRule03(a: SGFNode) throws -> SGFNode {
    return a
 }
            if case .yy27(let a) = yySymbolOnStack(distanceFromTop: 1) {
                return .yy27(try codeBlockForRule03(a: a))
            }
        case 4: /* gametree ::= OPEN_PARENTHESIS sequence(a) gametree_list(b) CLOSE_PARENTHESIS */
            func codeBlockForRule04(a: SGFNode, b: [SGFNode]) throws -> SGFNode {
    var node = a
    while node.children.count > 0 {
        node = node.children[0]
    }
    node.children.append(contentsOf: b)
    return a
 }
            if case .yy27(let a) = yySymbolOnStack(distanceFromTop: 2),
               case .yy11(let b) = yySymbolOnStack(distanceFromTop: 1) {
                return .yy27(try codeBlockForRule04(a: a, b: b))
            }
        case 5: /* gametree_list ::= gametree(a) */
            func codeBlockForRule05(a: SGFNode) throws -> [SGFNode] {
    return [a]
 }
            if case .yy27(let a) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy11(try codeBlockForRule05(a: a))
            }
        case 6: /* gametree_list ::= gametree(a) gametree_list(b) */
            func codeBlockForRule06(a: SGFNode, b: [SGFNode]) throws -> [SGFNode] {
    return [a] + b
 }
            if case .yy27(let a) = yySymbolOnStack(distanceFromTop: 1),
               case .yy11(let b) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy11(try codeBlockForRule06(a: a, b: b))
            }
        case 7: /* sequence ::= node(a) */
            func codeBlockForRule07(a: SGFNode) throws -> SGFNode {
    return a
 }
            if case .yy27(let a) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy27(try codeBlockForRule07(a: a))
            }
        case 8: /* sequence ::= node(a) sequence(b) */
            func codeBlockForRule08(a: SGFNode, b: SGFNode) throws -> SGFNode {
    a.children.append(b)
    return a
 }
            if case .yy27(let a) = yySymbolOnStack(distanceFromTop: 1),
               case .yy27(let b) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy27(try codeBlockForRule08(a: a, b: b))
            }
        case 9: /* node ::= SEMICOLUMN */
            func codeBlockForRule09() throws -> SGFNode {
    return SGFNode()
 }
            return .yy27(try codeBlockForRule09())
        case 10: /* node ::= SEMICOLUMN property_list(a) */
            func codeBlockForRule10(a: [(String, [String])]) throws -> SGFNode {
    let node = SGFNode()
    for (k, v) in a {
        node.properties[k] = v
    }
    return node
 }
            if case .yy2(let a) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy27(try codeBlockForRule10(a: a))
            }
        case 11: /* property_list ::= property(a) */
            func codeBlockForRule11(a: (String, [String])) throws -> [(String, [String])] {
    return [a]
 }
            if case .yy28(let a) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy2(try codeBlockForRule11(a: a))
            }
        case 12: /* property_list ::= property(a) property_list(b) */
            func codeBlockForRule12(a: (String, [String]), b: [(String, [String])]) throws -> [(String, [String])] {
    return [a] + b
 }
            if case .yy28(let a) = yySymbolOnStack(distanceFromTop: 1),
               case .yy2(let b) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy2(try codeBlockForRule12(a: a, b: b))
            }
        case 13: /* property ::= PROP_INDENT(a) prop_value_list(b) */
            func codeBlockForRule13(a: SGFToken, b: [String]) throws -> (String, [String]) {
    return (a.toIdentifierString()!, b)
 }
            if case .yy0(let a) = yySymbolOnStack(distanceFromTop: 1),
               case .yy10(let b) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy28(try codeBlockForRule13(a: a, b: b))
            }
        case 14: /* prop_value_list ::= VALUE(a) */
            func codeBlockForRule14(a: SGFToken) throws -> [String] {
    return [a.toValueString()!]
 }
            if case .yy0(let a) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy10(try codeBlockForRule14(a: a))
            }
        case 15: /* prop_value_list ::= VALUE(a) prop_value_list(b) */
            func codeBlockForRule15(a: SGFToken, b: [String]) throws -> [String] {
    return [a.toValueString()!] + b
 }
            if case .yy0(let a) = yySymbolOnStack(distanceFromTop: 1),
               case .yy10(let b) = yySymbolOnStack(distanceFromTop: 0) {
                return .yy10(try codeBlockForRule15(a: a, b: b))
            }
        default:
            fatalError("Can't invoke code block for rule number \(ruleNumber) - no such rule")
        }
        fatalError("Can't resolve types correctly for invoking code block for rule number \(ruleNumber)")
    }

    private func yySymbolOnStack(distanceFromTop: Int) -> CitronSymbol {
        assert(yyStack.count > distanceFromTop)
        return yyStack[yyStack.count - 1 - distanceFromTop].symbol
    }

    func yyUnwrapResultFromSymbol(_ symbol: CitronSymbol) -> CitronResult {
        if case .yy11(let result) = symbol {
            return result
        } else {
            fatalError("Unexpected mismatch in result type")
        }
    }

    // Error capturing

    typealias CitronErrorCaptureDelegate = _SGFParserCitronErrorCaptureDelegate

    weak var errorCaptureDelegate: CitronErrorCaptureDelegate? = nil

    let yyErrorCaptureSymbolNumbersForState: [CitronStateNumber:[CitronSymbolNumber]] = [:]
    let yyCanErrorCapture: Bool = false
    let yyErrorCaptureDirectives: [CitronSymbolNumber:(endAfter:[[CitronTokenCode]],endBefore:[CitronTokenCode])] = [:]
    let yyErrorCaptureEndBeforeTokens: Set<CitronSymbolNumber> = []

    let yyErrorCaptureEndAfterSequenceEndingTokens: Set<CitronSymbolNumber> = []

    func yyShouldSaveErrorForCapturing(error: Error) -> Bool {
        fatalError("This parser was not generated with error capturing information")
    }

    func yyCaptureError(on symbolCode: CitronNonTerminalCode, error: Error, state: CitronErrorCaptureState) -> CitronSymbol? {
        fatalError("This parser was not generated with error capturing information")
    }

    func yySymbolContent(_ symbol: CitronSymbol) -> Any { return symbol.typeErasedContent() }

    let yyStartSymbolNumber: CitronSymbolNumber = 14
    let yyEndStateNumber: CitronStateNumber = 11

    var yyErrorCaptureSavedError: (error: Error, isLexerError: Bool)? = nil
    var yyErrorCaptureTokensSinceError: [(token: CitronToken, tokenCode: CitronTokenCode)] = []
    var yyErrorCaptureStackIndices: [Int] = []
    var yyErrorCaptureStartSymbolStackIndex: Int? = nil

    var numberOfCapturedErrors: Int = 0
}

protocol _SGFParserCitronErrorCaptureDelegate : class {
    func shouldSaveErrorForCapturing(error: Error) -> Bool
}

extension _SGFParserCitronErrorCaptureDelegate {
    func shouldSaveErrorForCapturing(error: Error) -> Bool {
        return true
    }
}

// Ability to use == to compare CitronSymbolCode with CitronTokenCode / CitronNonTerminalCode

extension SGFParser.CitronSymbolCode {
    static func == (a: SGFParser.CitronSymbolCode, b: SGFParser.CitronTokenCode) -> Bool {
        guard case let .token(code) = a else { return false }
        return (code == b)
    }
    static func == (a: SGFParser.CitronTokenCode, b: SGFParser.CitronSymbolCode) -> Bool {
        guard case let .token(code) = b else { return false }
        return (code == a)
    }
    static func == (a: SGFParser.CitronSymbolCode, b: SGFParser.CitronNonTerminalCode) -> Bool {
        guard case let .nonterminal(code) = a else { return false }
        return (code == b)
    }
    static func == (a: SGFParser.CitronNonTerminalCode, b: SGFParser.CitronSymbolCode) -> Bool {
        guard case let .nonterminal(code) = b else { return false }
        return (code == a)
    }
}

// Ability to use switch (symbolCode) { case .tokenCode: ...; case .nonterminalCode: ... }

extension SGFParser.CitronSymbolCode {
    static func ~= (pattern: SGFParser.CitronTokenCode, value: SGFParser.CitronSymbolCode) -> Bool {
        return (pattern == value)
    }
    static func ~= (pattern: SGFParser.CitronNonTerminalCode, value: SGFParser.CitronSymbolCode) -> Bool {
        return (pattern == value)
    }
}
